/*

Copyright (c) 2006 Kenji ABE <abek@terre-sys.com>

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions: The above copyright notice and this
permission notice shall be included in all copies or substantial
portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH
THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE EVEN IF
ADVISED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.

*/

#ifndef IM_CARET_H
#define	IM_CARET_H

#include "imdef.h"

#ifdef	__cplusplus
extern "C" {
#endif

extern Bool handle_caret_move_begin(iml_session_t *session, IMKeyEventStruct *key_event, iml_inst **inst_list);
extern Bool handle_caret_move_end(iml_session_t *session, IMKeyEventStruct *key_event, iml_inst **inst_list);
extern Bool handle_caret_move_left(iml_session_t *session, IMKeyEventStruct *key_event, iml_inst **inst_list);
extern Bool handle_caret_move_right(iml_session_t *session, IMKeyEventStruct *key_event, iml_inst **inst_list);

extern Bool handle_expand_current_segment(iml_session_t *session, IMKeyEventStruct *key_event, iml_inst **inst_list);
extern Bool handle_shrink_current_segment(iml_session_t *session, IMKeyEventStruct *key_event, iml_inst **inst_list);

extern void make_caret_move_inst(iml_session_t *session, int caret_pos, iml_inst **inst_list);

#ifdef __cplusplus
}
#endif

#endif /* IM_CARET_H */

/* Local Variables: */
/* c-file-style: "iiim-project" */
/* End: */
