/* 
 * Copyright (C) 2008 Sun Microsystems
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authors: Aijin Kim <Aijin.Kim@Sun.COM>
 */

#ifndef IME_BUFFER_H
#define IME_BUFFER_H

#include "ime.h"

#define IME_PREEDIT_AREA                1
#define IME_LOOKUP_AREA                 2
#define IME_STATUS_AREA                 4
#define IME_COMMIT                      8

typedef struct _ImeBufferRec {
    ImePreeditRec       preedit;
    ImeCandidatesRec    candidates;
    unsigned char      *commit_buf;
    int                 return_status;
    int                 max_cand_num;  //used for free the space. do not use it any other place.
} ImeBufferRec;

ImeBufferRec * alloc_ime_buffer(int max_preedit_bytes,      //max byte lenght of the preedit buffer
                                int max_candidate_num,      //max number of candidates
                                int max_candidate_byte,     //max byte length of single candidates
                                int max_numberring_byte,    //max byte length of single numberring
                                int max_commit_byte);       //max byte length of the commit buffer

void free_ime_buffer(ImeBufferRec *ime_buffer);

void clear_ime_buffer(ImeBufferRec *ime_buffer);

#endif
