/*
Copyright 1990-2008 Sun Microsystems, Inc. All Rights Reserved.

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions: The above copyright notice and this
permission notice shall be included in all copies or substantial
portions of the Software.


THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE OPEN GROUP OR SUN MICROSYSTEMS, INC. BE LIABLE
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH
THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE EVEN IF
ADVISED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.


Except as contained in this notice, the names of The Open Group and/or
Sun Microsystems, Inc. shall not be used in advertising or otherwise to
promote the sale, use or other dealings in this Software without prior
written authorization from The Open Group and/or Sun Microsystems,
Inc., as applicable.


X Window System is a trademark of The Open Group

OSF/1, OSF/Motif and Motif are registered trademarks, and OSF, the OSF
logo, LBX, X Window System, and Xinerama are trademarks of the Open
Group. All other trademarks and registered trademarks mentioned herein
are the property of their respective owners. No right, title or
interest in or to any trademark, service mark, logo or trade name of
Sun Microsystems, Inc. or its licensors is granted.

*/
/*
 * File:   iiimvkb.h
 * Author: naoyuki
 *
 * Created on 2008/03/27, 19:37
 */

#ifndef _IIIMVKB_H
#define	_IIIMVKB_H

#include "iiimcf.h"

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef BOOL
#undef BOOL
#endif
typedef int BOOL;

#ifdef FALSE
#undef FALSE
#endif
#define FALSE 0
#ifdef TRUE
#undef TRUE
#endif
#define TRUE 1

/* borrow from xcf */
typedef enum {
  IM_OFF = 0,
  IM_ON
} IMEnabled;

typedef enum {
  LS_IC,
  LS_DESKTOP
} LangSwitchPolicy;

typedef enum {
  OO_ACTIVATE,
  OO_DONOT_CHANGE
} OnOffPolicy;

typedef struct {
  LangSwitchPolicy lang_switch_policy;
  OnOffPolicy on_off_policy;
  int kbd_layout;
  IMEnabled sync_activation;
  IMEnabled remember_last_le;
} IIIMSettings;

extern void cf_send_text (const IIIMP_card16 *text, int len, const char *text8);
extern void cf_send_key (const int code, const int ch, const int modifier, const int time_stamp);
extern void cf_synchronize_keyboard (const char *name);
extern void cf_reset_synchronize_keyboard ();
extern void cf_invoke_native_help ();


#ifdef	__cplusplus
}
#endif

#endif	/* _IIIMVKB_H */

