#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <gtk/gtk.h>

#include <gconf/gconf-client.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

/*---------------------------- General ---------------------------*/
/*----------------------------------------------------------------*/
/*------------------- Enable Input Methoud -----------------------*/
void general_enable_im_toggled (GtkToggleButton *, gpointer);
void
on_enableCheckBox_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  general_enable_im_toggled (togglebutton, user_data);
}

/*----------------- Enable InputMethoud Switcher ------------------*/
/*
void general_enable_switcher_toggled (GtkToggleButton *, gpointer);
void
on_switcherCheckBox_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  general_enable_switcher_toggled (togglebutton, user_data);
}
*/

/*----------------- Display input methoud status -----------------*/
/*
void general_enable_status_toggled (GtkToggleButton *, gpointer);
void
on_statusCheckBox_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  general_enable_status_toggled (togglebutton, user_data);
}
*/


/*-------------------- Synchronize Activatio-----------------------*/
void general_sync_activation_toggled (GtkToggleButton *, gpointer);
void
on_syncActivationCheckBox_toggled      (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  general_sync_activation_toggled (togglebutton, user_data);
}

/*-------------------- Placement ---------------------------------*/
void general_status_place_changed (GtkComboBox *, gpointer);
void
on_statusPlacementComboBox_changed         (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
  general_status_place_changed (combobox, user_data);
}

/*--------------------- Per IC/Desktop ---------------------------*/
void general_lang_per_ic_or_desktop_button_toggled (GtkToggleButton *, gpointer);
void
on_perDesktopCheckbox_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  general_lang_per_ic_or_desktop_button_toggled (togglebutton, user_data);
}

/*----------------------- On/Off policy --------------------------*/
void general_im_activate_policy_button_toggled (GtkToggleButton *, gpointer);
void
on_onoffCheckbox_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  general_im_activate_policy_button_toggled (togglebutton, user_data);
}

/*-------------------- Remember last le selection ------------------*/
void general_remember_last_le_button_toggled (GtkToggleButton *, gpointer);
void
on_remLastCheckbox_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  general_remember_last_le_button_toggled (togglebutton, user_data);
}

/*----------------- Languages/Scripts ------------------------------*/
/*------------------------------------------------------------------*/
/*---------- Available Language/Script list ------------*/
void lang_available_lang_list_clicked (GtkTreeView *, gpointer);

void
on_availableLangList_cursor_changed    (GtkTreeView     *treeview,
                                        gpointer         user_data)
{
  lang_available_lang_list_clicked (treeview, user_data);
}

/*------------- Add Lanuguage button ---------------*/
void lang_add_lang_button_clicked (GtkButton *, gpointer);

void
on_addLangButton_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  lang_add_lang_button_clicked (button, user_data);
}

/*------------- Languages/Scripts to input list --------*/
void lang_use_lang_list_clicked (GtkTreeView *, gpointer);

void
on_useLangList_cursor_changed          (GtkTreeView     *treeview,
                                        gpointer         user_data)
{
  lang_use_lang_list_clicked (treeview, user_data);
}

/*-------------- Del Language button -------------------*/
void lang_del_lang_button_clicked (GtkButton *, gpointer);

void
on_delLangButton_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  lang_del_lang_button_clicked (button, user_data);
}

/*-------------- Up Language button --------------------*/
void lang_up_lang_button_clicked (GtkButton *, gpointer);
void
on_upLangButton_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  lang_up_lang_button_clicked (button, user_data);
}

/*-------------- Down Language button ------------------*/
void lang_down_lang_button_clicked (GtkButton *, gpointer);

void
on_downLangButton_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
  lang_down_lang_button_clicked (button, user_data);
}


/*------------- Available Engine list ------------------*/
void lang_available_engine_list_clicked (GtkTreeView *, gpointer);

void
on_availableEngineList_cursor_changed  (GtkTreeView     *treeview,
                                        gpointer         user_data)
{
  lang_available_engine_list_clicked (treeview, user_data);
}

/*------------ Use Engine list ------------------------*/
void lang_use_engine_list_clicked (GtkTreeView *, gpointer);

void
on_useEngineList_cursor_changed        (GtkTreeView     *treeview,
                                        gpointer         user_data)
{
  lang_use_engine_list_clicked (treeview, user_data);
}

/*-------------- Add Engine button -------------------*/
void lang_add_engine_button_clicked (GtkButton *, gpointer);

void
on_addLEButton_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  lang_add_engine_button_clicked (button, user_data);
}

/*-------------- Del Engine button -------------------*/
void lang_del_engine_button_clicked (GtkButton *, gpointer);

void
on_delLEButton_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  lang_del_engine_button_clicked (button, user_data);
}

/*-------------- Up Engine button -------------------*/
void lang_up_engine_button_clicked (GtkButton *, gpointer);

void
on_upLEButton_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  lang_up_engine_button_clicked (button, user_data);
}

/*-------------- Down Engine button -------------------*/
void lang_down_engine_button_clicked (GtkButton *, gpointer);

void
on_downLEButton_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  lang_down_engine_button_clicked (button, user_data);
}

/*------------------------ Trigger Keys-----------------------------*/
/*------------------------------------------------------------------*/
void trigger_keys_list_clicked (GtkTreeView *, gpointer);
void
on_triggerList_cursor_changed          (GtkTreeView     *treeview,
                                        gpointer         user_data)
{
  trigger_keys_list_clicked (treeview, user_data);
}

void trigger_add_button_clicked (GtkButton *, gpointer);
void
on_triggerAddButton_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  trigger_add_button_clicked (button, user_data);
}

void trigger_remove_button_clicked (GtkButton *, gpointer);
void
on_triggerRemoveButton_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
  trigger_remove_button_clicked (button, user_data);
}

/*-------------------------- Misc ----------------------------------*/
/*------------------------------------------------------------------*/
void misc_enable_list_toggled (GtkToggleButton *, gpointer);
void
on_langListEnableToggleButton_toggled  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  misc_enable_list_toggled (togglebutton, user_data);
}

void misc_enable_cycle_toggled (GtkToggleButton *, gpointer);
void
on_enableMiscHotkeyToggleButton_toggled
                                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  misc_enable_cycle_toggled (togglebutton, user_data);
}

void misc_list_hotkey_clicked (GtkTreeView *, gpointer);
void
on_popupHotkeyList_cursor_changed      (GtkTreeView     *treeview,
                                        gpointer         user_data)
{
  misc_list_hotkey_clicked (treeview, user_data);
}

void misc_add_list_hotkey_clicked (GtkButton *, gpointer);
void
on_popupHotkeyAddButton_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  misc_add_list_hotkey_clicked (button, user_data);
}

void misc_remove_list_hotkey_clicked (GtkButton *, gpointer);
void
on_popupHotkeyRemoveButton_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
  misc_remove_list_hotkey_clicked (button, user_data);
}

void misc_cycle_hotkey_clicked (GtkTreeView *, gpointer);
void
on_langswitchHotkeyList_cursor_changed (GtkTreeView     *treeview,
                                        gpointer         user_data)
{
  misc_cycle_hotkey_clicked (treeview, user_data);
}

void misc_add_cycle_hotkey_clicked (GtkButton *, gpointer);
void
on_langswitchHotkeyAddButton_clicked   (GtkButton       *button,
                                        gpointer         user_data)
{
  misc_add_cycle_hotkey_clicked (button, user_data);
}

void misc_remove_cycle_hotkey_clicked (GtkButton *, gpointer);
void
on_langswitchHotkeyRemoveButton_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
  misc_remove_cycle_hotkey_clicked (button, user_data);
}

void misc_reverse_cycle_hotkey_clicked (GtkTreeView *, gpointer);
void
on_reverseLangswitchHotkeyList_cursor_changed
                                        (GtkTreeView     *treeview,
                                        gpointer         user_data)
{
  misc_reverse_cycle_hotkey_clicked (treeview, user_data);
}

void misc_add_reverse_cycle_hotkey_clicked (GtkButton *, gpointer);
void
on_reverseLangswitchHotkeyAddButton_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
  misc_add_reverse_cycle_hotkey_clicked (button, user_data);
}

void misc_remove_reverse_cycle_hotkey_clicked (GtkButton *, gpointer);
void
on_reverseLangswitchHotkeyRemoveButton_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
  misc_remove_reverse_cycle_hotkey_clicked (button, user_data);
}

/*----------------- Help/Cancel/Apply/OK --------------------------*/
/*--------------- Help button -------------------------------------*/
void exec_help (GtkButton *, gpointer);

void
on_helpButton_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  exec_help (button, user_data);
}

/*------------------ Cancel button -------------------------------*/
void exec_cancel (GtkButton *, gpointer);

void
on_cancelButton_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  exec_cancel (button, user_data);
}

/*------------------- Apply button -------------------------------*/
void exec_apply (GtkButton *, gpointer);

void
on_applyButton_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  exec_apply (button, user_data);
}

/*------------------- OK button ----------------------------------*/
void exec_ok (GtkButton *, gpointer);

void
on_okButton_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  exec_ok (button, user_data);
}

/*----------------- Hotkey Config dialog--------------------------*/
/*------------------------------------------------------------------*/
void hkc_key_pressed (GtkWidget *, GdkEventKey *);
gboolean
on_hkc_canvas_key_press_event          (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  hkc_key_pressed (widget, event);
  return FALSE;
}

void hkc_key_released (GtkWidget *, GdkEventKey *);
gboolean
on_hkc_canvas_key_release_event        (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  hkc_key_released (widget, event);
  return FALSE;
}

void hkc_help (GtkButton *);
void
on_hkc_helpbutton_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
  hkc_help (button);
}

void hkc_add (GtkButton *);
void
on_hkc_addbutton_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  hkc_add (button);
}

void hkc_focus_in (GtkWidget *);
gboolean
on_hkc_canvas_focus_in_event           (GtkWidget       *widget,
                                        GdkEventFocus   *event,
                                        gpointer         user_data)
{
  hkc_focus_in (widget);
  return FALSE;
}

void hkc_focus_out (GtkWidget *);
gboolean
on_hkc_canvas_focus_out_event          (GtkWidget       *widget,
                                        GdkEventFocus   *event,
                                        gpointer         user_data)
{
  hkc_focus_out (widget);
  return FALSE;
}


void hkc_expose (GtkWidget *, GdkEventExpose *);
gboolean
on_hkc_canvas_expose_event             (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
  hkc_expose (widget, event);
  return FALSE;
}

void hkc_close (GtkButton *);
void
on_hkc_closebutton_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  hkc_close (button);
}

void exec_change_page (guint);
void
on_notebook1_switch_page               (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        guint            page_num,
                                        gpointer         user_data)
{
  exec_change_page (page_num);
}

/*---------------------------- Keyboard ---------------------------*/
/*----------------------------------------------------------------*/
void keyboard_layout_changed (GtkTreeView *, gpointer);
void
on_keyboardLayoutList_cursor_changed   (GtkTreeView     *treeview,
                                        gpointer         user_data)
{
  keyboard_layout_changed (treeview, user_data);
}

void keyboard_autodetect_toggled (GtkToggleButton *togglebutton, gpointer user_data);
void
on_keyboardAutodetectCheckButton_toggled
                                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  keyboard_autodetect_toggled (togglebutton, user_data);
}
